#ifndef DISASSEMBLYCONTEXTMENU_H
#define DISASSEMBLYCONTEXTMENU_H

#include "cutter.h"
#include <QMenu>
#include <QKeySequence>

class DisassemblyContextMenu : public QMenu
{
Q_OBJECT

public:
    DisassemblyContextMenu(QWidget *parent = nullptr);
    ~DisassemblyContextMenu() = default;

signals:
    void copy();

public slots:
    void setOffset(RVA offset);
    void setCanCopy(bool enabled);

private slots:
    void aboutToShowSlot();

    void on_actionCopy_triggered();

    void on_actionAddComment_triggered();
    void on_actionAddFlag_triggered();
    void on_actionRename_triggered();
    void on_actionRenameUsedHere_triggered();
    void on_actionXRefs_triggered();
    void on_actionDisplayOptions_triggered();

    void on_actionSetBaseBinary_triggered();
    void on_actionSetBaseOctal_triggered();
    void on_actionSetBaseDecimal_triggered();
    void on_actionSetBaseHexadecimal_triggered();
    void on_actionSetBasePort_triggered();
    void on_actionSetBaseIPAddr_triggered();
    void on_actionSetBaseSyscall_triggered();
    void on_actionSetBaseString_triggered();

private:
    QKeySequence getCopySequence() const;
    QKeySequence getCommentSequence() const;
    QKeySequence getAddFlagSequence() const;
    QKeySequence getRenameSequence() const;
    QKeySequence getRenameUsedHereSequence() const;
    QKeySequence getXRefSequence() const;
    QKeySequence getDisplayOptionsSequence() const;

    RVA offset;
    bool canCopy;

    QAction actionCopy;
    QAction *copySeparator;

    QAction actionAddComment;
    QAction actionAddFlag;
    QAction actionRename;
    QAction actionRenameUsedHere;
    QAction actionXRefs;
    QAction actionDisplayOptions;

    QMenu *setBaseMenu;
    QAction *setBaseMenuAction;
    QAction actionSetBaseBinary;
    QAction actionSetBaseOctal;
    QAction actionSetBaseDecimal;
    QAction actionSetBaseHexadecimal;
    QAction actionSetBasePort;
    QAction actionSetBaseIPAddr;
    QAction actionSetBaseSyscall;
    QAction actionSetBaseString;
};
#endif // DISASSEMBLYCONTEXTMENU_H
